//+------------------------------------------------------------------+
//|                                        Brooky_Trend_Strength.mq4 |
//|                                          Copyright  2010,Brooky |
//|                               http://forex-indicators.weebly.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010,Brooky"
#property link      "http://forex-indicators.weebly.com"
#property link      "www.fprex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Chartreuse
#property indicator_color2 Crimson
#property indicator_width1 1
#property indicator_width2 1
#property indicator_level1 0


extern int timeFrame = 0;
extern int Atr_Std_Period=14;
double atr_buff[];
double sig_buff[];
string indicatorFileName;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   timeFrame = MathMax(timeFrame,Period());
      SetIndexBuffer(0,atr_buff);SetIndexStyle(0,DRAW_LINE);
      SetIndexBuffer(1,sig_buff);SetIndexStyle(1,DRAW_LINE);
         IndicatorShortName("Trend Strength Period ("+Atr_Std_Period+")");   
         indicatorFileName = WindowExpertName();
   return(0);
}
int deinit() { return(0);  }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (timeFrame!=Period())
           {
               limit = MathMin(MathMax(limit,3*timeFrame/Period()),Bars-1);
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);
                     atr_buff[i] = iCustom(NULL,timeFrame,indicatorFileName,0,Atr_Std_Period,0,y);
                     sig_buff[i] = iCustom(NULL,timeFrame,indicatorFileName,0,Atr_Std_Period,1,y);
               }
               return(0);
           }
     for(i=limit; i>=0; i--) atr_buff[i] = iStdDev(NULL,0,Atr_Std_Period,0,MODE_EMA,PRICE_CLOSE,i)-iATR(NULL,0,Atr_Std_Period,i);
     for(i=limit; i>=0; i--) sig_buff[i] = iMAOnArray(atr_buff,0,5,0,MODE_LWMA,i);
     return(0);
}